{
 FARUK DEMREL
 9.7.1997
 Component : DBCalEd.pas  : Data Aware Calendered DBedit
 e-mailware; fdemirel@kkk.tsk.mil.tr

 Installation:
 .Simply copy the DBCalEd.pas file into the LIB directory and
 add it to the complib32.dcl by using COOMPONENT|INSTALL menu.

 Usage:

 Drop it on the form and set the database connections as if regular DBEdit.

 Dblclick Event has been overriden according to show a calendar. So The code in
 the onDblclick procedure will be ignored.

 The date can be entered manually or automatically by dblclicking on
 the component.

 The Calendar buttons have hint about their functions.

 .You can use,distribute or modify freely.
 .if you modify it please send me a copy.
 .I want to hear about your comments.
}

unit dbcaled;

interface

uses
  Windows, Messages, Classes,graphics,
  Controls,  Dialogs,  Buttons, StdCtrls,
   Calendar,db,DBCtrls,sysutils,extctrls;
   //dbtables,forms

type
  TDBCalEdit = class(TDBEdit)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  procedure DblClick;override;
  procedure Takvimyap;
  procedure Takvimkapat;
  procedure mybtnclick(sender:tobject);
  constructor create(aowner:tcomponent);override;
  published
    { Published declarations }
  end;

  {++++++++++++++++++++}

procedure register;
implementation
var

takvimpanel:tpanel;
takvim:tcalendar;
takvimbtn:array [1..6] of tspeedbutton;
takvimedit:tedit;

procedure Tdbcaledit.DblClick;
begin
  if (datafield<>'') then
  takvimyap;
end;

constructor Tdbcaledit.create(aowner:tcomponent);
begin
  inherited create(aowner);
  color:=clsilver;
  hint:='Takvimi amak iin ift tklaynz / DoubleClick to show the calendar.';
  showhint:=true;
end;

procedure Register;
begin
  RegisterComponents('Faruk', [TDBCalEdit]);
end;

{*********}

procedure tdbcaledit.Takvimyap;
var
i:integer;

begin
   {takvim paneli}
        takvimpanel:=tpanel.create(self);
        takvimpanel.width:=250;
        takvimpanel.height:=160;
        takvimpanel.parent:=parent;
        takvimpanel.left:=left  ;
        takvimpanel.top:=top+height+1;

   {takvim}
        takvim:=tcalendar.create(takvimpanel);
        takvim.parent:=takvimpanel;
        takvim.left:=10;
        takvim.top:=10;
        takvim.width:=200;
        takvim.color:=color;
        takvim.font.color:=font.color;
   {takvim butonlar}
        for i:=1 to 6 do
        begin
             takvimbtn[i]:=tspeedbutton.create(self);
             takvimbtn[i].parent:=takvimpanel;
             takvimbtn[i].left:=215;
             takvimbtn[i].width:=25;
             takvimbtn[i].height:=22;
             takvimbtn[i].top:=10+25*(i-1);
             takvimbtn[i].onclick:=mybtnclick;
             takvimbtn[i].tag:=i;
             takvimbtn[i].showhint:=true;
        end;
        takvimbtn[1].caption:='<<';
        takvimbtn[1].hint:='nceki Yl / PrevYear';
        takvimbtn[2].caption:='<';
        takvimbtn[2].hint:='nceki Ay / PrevMonth';
        takvimbtn[3].caption:='>';
        takvimbtn[3].hint:='Sonraki Ay / NextMonth';
        takvimbtn[4].caption:='>>';
        takvimbtn[4].hint:='Sonraki Yl / NextYear';
        takvimbtn[5].caption:='T';
        takvimbtn[5].hint:='Tamam / OK';
        takvimbtn[6].caption:='X';
        takvimbtn[6].hint:='ptal / Cancel';


   {takvim editi}
        takvimedit:=tedit.create(self);
        takvimedit.parent:=takvimpanel;
        takvimedit.left:=75 ;
        takvimedit.top:=130;
        takvimedit.width:=70;
        takvimedit.text:=datetostr(takvim.calendardate);
        takvimedit.readonly:=true;
end;

procedure tdbcaledit.Takvimkapat;
var
   i:integer;
begin

   for i:=1 to 5 do takvimbtn[i].free;
   takvim.free;
   takvimedit.free;
   takvimpanel.free;

end;

procedure tdbcaledit.mybtnclick(sender:tobject);
begin

  case (sender as tspeedbutton).tag of
  1:{- yl}begin
           takvim.prevyear;
           takvimedit.text:=FormatDateTime('DD.MM.YYYY',takvim.CalendarDate);
           end;
  2:{- ay}begin
          takvim.prevmonth;
          takvimedit.text:=FormatDateTime('DD.MM.YYYY',takvim.CalendarDate);
          end;

  3:{+ yl}begin
           takvim.nextmonth;
           takvimedit.text:=FormatDateTime('DD.MM.YYYY',takvim.CalendarDate);
           end;

  4:{+ ay} begin
           takvim.nextyear;
           takvimedit.text:=FormatDateTime('DD.MM.YYYY',takvim.CalendarDate);
           end;

  5:{kapat}begin
           datasource.dataset.edit;
           text:=FormatDateTime('DD.MM.YYYY',takvim.CalendarDate);
           datasource.dataset.post;
           takvimkapat;
           end;
  6:{ptal}begin
           takvimkapat;
           end;

  end;
end;


end.
